//+------------------------------------------------------------------+
//|                                                 MyMartingale.mqh |
//|                                                       Oleg Peyko |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Oleg Peyko"
#property link      "http://www.mql5.com"

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class MyMartingale
  {
private:
   double            MyMartingale_currBal;
   double            MyMartingale_prevBal;
   double            MyMartingale_startLot;
   double            MyMartingale_step;
   double            MyMartingale_multiplier;

   void              CalcProfitLoss()
     {
      if(MyMartingale_currBal>MyMartingale_prevBal)
        {
         MyMartingale_step=0;
        }
      if(MyMartingale_currBal<MyMartingale_prevBal)
        {
         MyMartingale_step++;
        }
      MyMartingale_prevBal = MyMartingale_currBal;
     }

public:
                     MyMartingale()
     {
      MyMartingale_currBal = 0;
      MyMartingale_prevBal = 0;
      MyMartingale_startLot = 0;
      MyMartingale_multiplier = 0;
      MyMartingale_step = 0;
     }

                     MyMartingale(double _currbal, double _startlot, double _multiplier)
     {
      MyMartingale_currBal = _currbal;
      MyMartingale_prevBal = _currbal;
      MyMartingale_startLot = _startlot;
      MyMartingale_multiplier = _multiplier;
      MyMartingale_step = 0;
     }

   double            GetLot(double _curbal)
     {
      MyMartingale_currBal = _curbal;
      CalcProfitLoss();
      double retval = MyMartingale_startLot;
      double calcval = NormalizeDouble(MyMartingale_startLot * MathPow(MyMartingale_multiplier,MyMartingale_step),2);
      if(calcval>retval)
         retval = calcval;
      return retval;
     }

   void              SetStartLot(double newlot)
     {
      if(newlot>0)
         MyMartingale_startLot = newlot;
     }
  };
//+------------------------------------------------------------------+
